type term = 

       | Id of string
	| Num of int
	| Bool of bool
        | String of string
	| Lam of string * term * term  
	| App of term * term 
        | Letval of string * term * term * term
        | Lettype of string * term * term * term
        | Letrecval of string * term * term * term
        | Letrectype of string * term * term * term
	| Clos of string * term * termenv
	| FClos of string * term * termenv
	| Ite of term * term * term
     | Ref of term
     | Deref of term
     | Assign of term * term
     | Loc of (term ref)
     | Kindcase of term * term * string * term * term
     | EmptyRec
	| RecCons of term * term * term
	| RLabel of term
	| RHead of term
	| RTail of term
	| REmpty of term

	| TInt
	| TBool
	| TString
	| TUnit
	| Ttop
	| Tbot

	| TLam of string * term * term
 	| TClos of string * term * termenv
	| TForall of string * term * term
	| TMap of term * term

     | Label of string

    	| TEmptyRec
	| TRecCons of term * term * term
	| TArrow of term * term
	| TDom of term
	| TCodom of term
	| TRef of term
	| TRefOf of term

	| TIte of term * term * term 

     | KRec
     | KFun
     | KType
     | KRef
     | KLab
	| KGen of term

	| KPi of string * term * term
     | KRefine of string * term * term

     | EqVal of term * term
     | NumTimes of term * term
     | NumPlus of term * term
     | NumMinus of term * term

     | StrConcat of term * term

     | Implies of term * term
     | And of term * term
     | Not of term 
     | Equiv of term * term * term
     | Equals of term * term * term
     | Or of term * term
     | LabSet of term
     | LabApart of term * term
     | In of term * term
     | LSet

     | LabConcat of term * term
     | LabUnion of term * term
     | LabSetConcat of term * term  

     | KindOK

  | KPiList of (string * term) list * term
  | AppList of term * term list

  | RecF of string * term * term
  | Tracer of term

and termenv = (string * term) list

and ihenv = (string * term * term) list

val print_term: term -> unit;;
